-----------------------------
--variables
-----------------------------

const
  --the tops
  NumTop:         6;

  --the good guys

  NumGoodNodes:    3;

  --the bad guys
  NumBadNodes:     1;

  TotalNodes:      NumGoodNodes + NumBadNodes;

  MaxSequenceNumber:     6;
  MaxDistance:   NumGoodNodes + NumBadNodes;

type

  RouteRow : record
    sequence_no : 0..MaxSequenceNumber;
    distance:     0..MaxDistance;
    --next_hop_id : AgentId;
  end;

  RouteTable : array[1..TotalNodes] of RouteRow;

  TopVector : array[1..TotalNodes] of boolean;
  TopVectors : array[1..TotalNodes] of TopVector;

  SpeedDial : array[1..TotalNodes] of 1..TotalNodes;
SpeedDials : array[1..NumGoodNodes] of SpeedDial;

  SpeedSizes : array[1..NumGoodNodes] of 0..TotalNodes;

var
  routing_tables: array[1..TotalNodes] of RouteTable;
  topology: array[1..NumTop] of TopVectors;
  top_id: 1..NumTop;
  turn_list: array[1..TotalNodes] of 1..TotalNodes;
  turn: 1..TotalNodes;
  speed_dial_list: array[1..NumTop] of SpeedDials;
  speed_dial_size: array[1..NumTop] of SpeedSizes;
  speed_dial_index: array[1..NumGoodNodes] of 1..TotalNodes;
  speed_dial_index2: 1..TotalNodes;
  printout: 1..2;
  badAbout: 1..TotalNodes;
  move_at: array[1..NumTop] of 1..TotalNodes;
  change_top : boolean;

----------------------------
--rules
----------------------------


rule 0 "The topology changes"

  (top_id < NumTop) & (change_top)

  ==>
  begin

  top_id := top_id + 1;
  
  routing_tables[move_at[top_id]][move_at[top_id]].sequence_no := 
    routing_tables[move_at[top_id]][move_at[top_id]].sequence_no + 1;

  change_top := FALSE;

  printout := 1;
/*
  for i : 1..TotalNodes do
      if ((move_at[top_id] <= NumGoodNodes) & (topology[top_id][i][move_at[top_id]] = FALSE)) then
	routing_tables[move_at[top_id]][i].distance := TotalNodes;
      end;
  end;


  for i : 1..TotalNodes do
      if ((i <= NumGoodNodes) & (topology[top_id][i][move_at[top_id]] = FALSE)) then

	routing_tables[i][move_at[top_id]].distance := TotalNodes;

    end;
  end;
*/

for i : 1..NumGoodNodes do
      for j : 1..TotalNodes do

	if (topology[top_id][i][j] = FALSE) then
	  routing_tables[i][j].distance := TotalNodes;
        
	  end;
	end;
end;



end;



ruleset change: boolean do
rule 100 "A good node performs a broadcast update"

  (turn_list[turn] <= NumGoodNodes) &
  exists j: 1..TotalNodes do
    exists k: 1..TotalNodes do
      (topology[top_id][turn_list[turn]][j] = true) &
      ((routing_tables[turn_list[turn]][k].distance < (MaxDistance-1)) &   
      (((routing_tables[turn_list[turn]][k].sequence_no > routing_tables[j][k].sequence_no) |
       ((routing_tables[turn_list[turn]][k].sequence_no = routing_tables[j][k].sequence_no) &
	(routing_tables[turn_list[turn]][k].distance + 1 < routing_tables[j][k].distance)))))
    end
  end

  ==>
  begin

  for j: 1..TotalNodes do
    for k: 1..TotalNodes do

	  if (j != k) &
      ((topology[top_id][turn_list[turn]][j] = true) &
      ((routing_tables[turn_list[turn]][k].distance < (MaxDistance-1)) &   
      (((routing_tables[turn_list[turn]][k].sequence_no > routing_tables[j][k].sequence_no) |
       ((routing_tables[turn_list[turn]][k].sequence_no = routing_tables[j][k].sequence_no) &
	(routing_tables[turn_list[turn]][k].distance + 1 <
	routing_tables[j][k].distance)))))) then

        routing_tables[j][k].sequence_no := routing_tables[turn_list[turn]][k].sequence_no;
        routing_tables[j][k].distance := routing_tables[turn_list[turn]][k].distance + 1;
   
      end;

    end;
  end;

  turn := (turn % TotalNodes) + 1;

  change_top := change;

end;
end;

ruleset change: boolean do
rule 200 "Enable Printout"

  (top_id = NumTop) &
  (printout = 1) &

  forall i: 1..NumGoodNodes do
    forall j: 1..TotalNodes do
      forall k: 1..TotalNodes do

	((j != k) &
        ((routing_tables[i][k].distance < (MaxDistance-1)) &   
        ((topology[top_id][i][j] = true) & 
        ((routing_tables[i][k].sequence_no > routing_tables[j][k].sequence_no) |
	((routing_tables[i][k].sequence_no = routing_tables[j][k].sequence_no) &
	 (routing_tables[i][k].distance + 1 < routing_tables[j][k].distance))))))
      
      ->
      false
  
      end
    end
  end

  ==>
  begin

    printout := 2;
    change_top := change;

end;
end;

ruleset change: boolean do
rule 250 "Update turn if no good node moves"
  (turn_list[turn] <= NumGoodNodes)
  ==>
  begin
    turn := (turn % TotalNodes) + 1;
    change_top := change;
end;
end;

ruleset change: boolean do
ruleset new_seq_no: 0..MaxSequenceNumber do
  ruleset new_distance: 1..(MaxDistance-1) do
    rule 300 "A bad node performs a broadcast update about a single other node"
      
      (turn_list[turn] > NumGoodNodes)

    
    ==>
    begin

    for j: 1..TotalNodes do
      if  (j != badAbout) &
          ((topology[top_id][turn_list[turn]][j] = true) &
	  ((routing_tables[turn_list[turn]][badAbout].sequence_no > new_seq_no) |
           ((routing_tables[turn_list[turn]][badAbout].sequence_no = new_seq_no) &
           (routing_tables[turn_list[turn]][badAbout].distance + 1 <= new_distance))) &
	  ((routing_tables[j][badAbout].sequence_no < new_seq_no) |
           ((routing_tables[j][badAbout].sequence_no = new_seq_no) &
            (routing_tables[j][badAbout].distance > new_distance)))) then

       routing_tables[j][badAbout].sequence_no := new_seq_no;  
       routing_tables[j][badAbout].distance := new_distance;
       printout := 1;

      end;
    end;

    if (badAbout = TotalNodes) then 
      turn := (turn % TotalNodes) + 1;
      change_top := change;
    end;
    badAbout := (badAbout % TotalNodes) + 1;

  end;
  end;
end;
end;


------------------------------
--startstate
------------------------------

startstate
  for i:= 1 to TotalNodes do
    for j:= 1 to TotalNodes do
      routing_tables[i][j].sequence_no := 0; 
      routing_tables[i][j].distance := MaxDistance;
    end;
  end;

  for i:= 1 to TotalNodes do
    routing_tables[i][i].distance := 0;
  end;

  printout := 1;
  turn := 1;

  for i:= 1 to NumGoodNodes do
    speed_dial_index[i] := 1;
  end;
  speed_dial_index2 := 1;

top_id := 1;
badAbout := 1;

turn_list[1] := 1;
turn_list[2] := 2;
turn_list[3] := 3;
turn_list[4] := 4;

change_top := FALSE;


move_at[1] := 1;
topology[1][1][1] := true;
topology[1][1][2] := true;
topology[1][1][3] := false;
topology[1][1][4] := true;
topology[1][2][1] := true;
topology[1][2][2] := true;
topology[1][2][3] := false;
topology[1][2][4] := true;
topology[1][3][1] := false;
topology[1][3][2] := false;
topology[1][3][3] := true;
topology[1][3][4] := false;
topology[1][4][1] := true;
topology[1][4][2] := true;
topology[1][4][3] := false;
topology[1][4][4] := true;
speed_dial_list[1][1][1] := 2;
speed_dial_list[1][1][2] := 4;
speed_dial_list[1][1][3] := 3;
speed_dial_list[1][1][4] := 1;
 speed_dial_size[1][1] := 2;
speed_dial_list[1][2][1] := 1;
speed_dial_list[1][2][2] := 4;
speed_dial_list[1][2][3] := 3;
speed_dial_list[1][2][4] := 2;
 speed_dial_size[1][2] := 2;
speed_dial_list[1][3][1] := 4;
speed_dial_list[1][3][2] := 2;
speed_dial_list[1][3][3] := 1;
speed_dial_list[1][3][4] := 3;
 speed_dial_size[1][3] := 0;
move_at[2] := 2;
topology[2][1][1] := true;
topology[2][1][2] := false;
topology[2][1][3] := false;
topology[2][1][4] := true;
topology[2][2][1] := false;
topology[2][2][2] := true;
topology[2][2][3] := false;
topology[2][2][4] := false;
topology[2][3][1] := false;
topology[2][3][2] := false;
topology[2][3][3] := true;
topology[2][3][4] := false;
topology[2][4][1] := true;
topology[2][4][2] := false;
topology[2][4][3] := false;
topology[2][4][4] := true;
speed_dial_list[2][1][1] := 4;
speed_dial_list[2][1][2] := 3;
speed_dial_list[2][1][3] := 2;
speed_dial_list[2][1][4] := 1;
 speed_dial_size[2][1] := 1;
speed_dial_list[2][2][1] := 4;
speed_dial_list[2][2][2] := 3;
speed_dial_list[2][2][3] := 1;
speed_dial_list[2][2][4] := 2;
 speed_dial_size[2][2] := 0;
speed_dial_list[2][3][1] := 4;
speed_dial_list[2][3][2] := 2;
speed_dial_list[2][3][3] := 1;
speed_dial_list[2][3][4] := 3;
 speed_dial_size[2][3] := 0;
move_at[3] := 1;
topology[3][1][1] := true;
topology[3][1][2] := false;
topology[3][1][3] := false;
topology[3][1][4] := false;
topology[3][2][1] := false;
topology[3][2][2] := true;
topology[3][2][3] := false;
topology[3][2][4] := false;
topology[3][3][1] := false;
topology[3][3][2] := false;
topology[3][3][3] := true;
topology[3][3][4] := false;
topology[3][4][1] := false;
topology[3][4][2] := false;
topology[3][4][3] := false;
topology[3][4][4] := true;
speed_dial_list[3][1][1] := 4;
speed_dial_list[3][1][2] := 3;
speed_dial_list[3][1][3] := 2;
speed_dial_list[3][1][4] := 1;
 speed_dial_size[3][1] := 0;
speed_dial_list[3][2][1] := 4;
speed_dial_list[3][2][2] := 3;
speed_dial_list[3][2][3] := 1;
speed_dial_list[3][2][4] := 2;
 speed_dial_size[3][2] := 0;
speed_dial_list[3][3][1] := 4;
speed_dial_list[3][3][2] := 2;
speed_dial_list[3][3][3] := 1;
speed_dial_list[3][3][4] := 3;
 speed_dial_size[3][3] := 0;
move_at[4] := 3;
topology[4][1][1] := true;
topology[4][1][2] := false;
topology[4][1][3] := false;
topology[4][1][4] := false;
topology[4][2][1] := false;
topology[4][2][2] := true;
topology[4][2][3] := false;
topology[4][2][4] := false;
topology[4][3][1] := false;
topology[4][3][2] := false;
topology[4][3][3] := true;
topology[4][3][4] := true;
topology[4][4][1] := false;
topology[4][4][2] := false;
topology[4][4][3] := true;
topology[4][4][4] := true;
speed_dial_list[4][1][1] := 4;
speed_dial_list[4][1][2] := 3;
speed_dial_list[4][1][3] := 2;
speed_dial_list[4][1][4] := 1;
 speed_dial_size[4][1] := 0;
speed_dial_list[4][2][1] := 4;
speed_dial_list[4][2][2] := 3;
speed_dial_list[4][2][3] := 1;
speed_dial_list[4][2][4] := 2;
 speed_dial_size[4][2] := 0;
speed_dial_list[4][3][1] := 4;
speed_dial_list[4][3][2] := 2;
speed_dial_list[4][3][3] := 1;
speed_dial_list[4][3][4] := 3;
 speed_dial_size[4][3] := 1;
move_at[5] := 1;
topology[5][1][1] := true;
topology[5][1][2] := true;
topology[5][1][3] := false;
topology[5][1][4] := false;
topology[5][2][1] := true;
topology[5][2][2] := true;
topology[5][2][3] := false;
topology[5][2][4] := false;
topology[5][3][1] := false;
topology[5][3][2] := false;
topology[5][3][3] := true;
topology[5][3][4] := true;
topology[5][4][1] := false;
topology[5][4][2] := false;
topology[5][4][3] := true;
topology[5][4][4] := true;
speed_dial_list[5][1][1] := 2;
speed_dial_list[5][1][2] := 4;
speed_dial_list[5][1][3] := 3;
speed_dial_list[5][1][4] := 1;
 speed_dial_size[5][1] := 1;
speed_dial_list[5][2][1] := 1;
speed_dial_list[5][2][2] := 4;
speed_dial_list[5][2][3] := 3;
speed_dial_list[5][2][4] := 2;
 speed_dial_size[5][2] := 1;
speed_dial_list[5][3][1] := 4;
speed_dial_list[5][3][2] := 2;
speed_dial_list[5][3][3] := 1;
speed_dial_list[5][3][4] := 3;
 speed_dial_size[5][3] := 1;
move_at[6] := 4;
topology[6][1][1] := true;
topology[6][1][2] := true;
topology[6][1][3] := false;
topology[6][1][4] := false;
topology[6][2][1] := true;
topology[6][2][2] := true;
topology[6][2][3] := false;
topology[6][2][4] := true;
topology[6][3][1] := false;
topology[6][3][2] := false;
topology[6][3][3] := true;
topology[6][3][4] := false;
topology[6][4][1] := false;
topology[6][4][2] := true;
topology[6][4][3] := false;
topology[6][4][4] := true;
speed_dial_list[6][1][1] := 2;
speed_dial_list[6][1][2] := 4;
speed_dial_list[6][1][3] := 3;
speed_dial_list[6][1][4] := 1;
 speed_dial_size[6][1] := 1;
speed_dial_list[6][2][1] := 1;
speed_dial_list[6][2][2] := 4;
speed_dial_list[6][2][3] := 3;
speed_dial_list[6][2][4] := 2;
 speed_dial_size[6][2] := 2;
speed_dial_list[6][3][1] := 4;
speed_dial_list[6][3][2] := 2;
speed_dial_list[6][3][3] := 1;
speed_dial_list[6][3][4] := 3;
 speed_dial_size[6][3] := 0;
end;
---------------------------------
-- invariants
---------------------------------

invariant "That is so true..."
  true;
--end;
